| acdvalid

## Wiki

The master copies of EMBOSS documentation are available at http://emboss.open-bio.org/wiki/Appdocs on the EMBOSS Wiki.

Please help by correcting and extending the Wiki pages.

## Function

Validate an application ACD file

## Description

acdvalid processes an ACD file and reports any errors or warnings caused by incorrect, deprecated or obsolete syntax. The tests go above and beyond those of acdc and acdtrace. It highlights ACD syntax that might cause problems to third-party parsing software which wrap the EMBOSS applications.

acdvalid validates the ACD file, testing many features which will not prevent an application from running, but will create problems for the interfaces, whether on the command-line or some other type.

## Usage

Here is a sample session with acdvalid

    % acdvalid antigenic

## Command line arguments

The first parameter is the name of the program to compile. All other command line parameters and qualifiers are defined for that program - see the documentation for the program of choice.

    Validate an application ACD file
    Version: EMBOSS:6.5.6.0

       Standard (Mandatory) qualifiers: (none)
       Additional (Optional) qualifiers: (none)
       Advanced (Unprompted) qualifiers: (none)
       Associated qualifiers: (none)
       General qualifiers:
       -auto               boolean    Turn off prompts
       -stdout             boolean    Write first file to standard output
       -filter             boolean    Read first file from standard input, write
                                      first file to standard output
       -options            boolean    Prompt for standard and additional values
       -debug              boolean    Write debug output to program.dbg
       -verbose            boolean    Report some/full command line options
       -help               boolean    Report command line options and exit. More
                                      information on associated and general
                                      qualifiers can be found with -help -verbose
       -warning            boolean    Report warnings
       -error              boolean    Report errors
       -fatal              boolean    Report fatal errors
       -die                boolean    Report dying program messages
       -version            boolean    Report version number and exit

Qualifier | Type | Description | Allowed values | Default
--- | --- | --- | --- | ---
Standard (Mandatory) qualifiers
(none)
Additional (Optional) qualifiers
(none)
Advanced (Unprompted) qualifiers
(none)
Associated qualifiers
(none)
General qualifiers
-auto | boolean | Turn off prompts | Boolean value Yes/No | N
-stdout | boolean | Write first file to standard output | Boolean value Yes/No | N
-filter | boolean | Read first file from standard input, write first file to standard output | Boolean value Yes/No | N
-options | boolean | Prompt for standard and additional values | Boolean value Yes/No | N
-debug | boolean | Write debug output to program.dbg | Boolean value Yes/No | N
-verbose | boolean | Report some/full command line options | Boolean value Yes/No | Y
-help | boolean | Report command line options and exit. More information on associated and general qualifiers can be found with -help -verbose | Boolean value Yes/No | N
-warning | boolean | Report warnings | Boolean value Yes/No | Y
-error | boolean | Report errors | Boolean value Yes/No | Y
-fatal | boolean | Report fatal errors | Boolean value Yes/No | Y
-die | boolean | Report dying program messages | Boolean value Yes/No | Y
-version | boolean | Report version number and exit | Boolean value Yes/No | N

## Input file format

The input is whatever the chosen application reads.

## Output file format

The output file is empty, but any format available to the specified program can be used.

## Data files

Acdvalid will use any data files specified in the ACD file of the specified program, but will ignore any data files that are only used directly by the program's code.

EMBOSS data files are distributed with the application and stored in the standard EMBOSS data directory, which is defined by the EMBOSS environment variable EMBOSS_DATA.

To see the available EMBOSS data files, run:

    % embossdata -showall

To fetch one of the data files (for example 'Exxx.dat') into your current directory for you to inspect or modify, run:

    % embossdata -fetch -file Exxx.dat

Users can provide their own data files in their own directories. Project specific files can be put in the current directory, or for tidier directory listings in a subdirectory called ".embossdata". Files for all EMBOSS runs can be put in the user's home directory, or again in a subdirectory called ".embossdata".

The directories are searched in the following order:

- . (your current directory)
- .embossdata (under your current directory)
- ~/ (your home directory)
- ~/.embossdata

## Notes

acdvalid does not have its own options, but takes a single parameter which is the name of the EMBOSS application that is being testsed. It is invoked by specifying the name of the application to be tested along with any command-line options after the name of the utility application itself:

acdvalid ApplicationName Options

acdvalid will run the command line interface of any EMBOSS program by reading its ACD file and processing the command line and user responses in exactly the same way as if the true program itself were running. The application proper is <emphasis>not</emphasis> run; it is only the ACD file that is read.Any command-line options for the application being called can be specified. The user is prompted for any required values for application parameters and any input files are read. Output files can be specified in any available format however they will be empty (the application code is not called so there will be no output).

acdvalid will use any data files specified in the ACD file of the specified program, but will ignore any data files that are only used directly by the program's code. EMBOSS data files are distributed with the application and stored in the standard EMBOSS data directory (see EMBOSS Users Manual for further information).

acdvalid generates both error and warning messages. If the message is an "Error" then the ACD file will not work and requires fixing. Most of the messages from acdvalid are "Warnings" and do not prevent a program from running, however it is still worth trying to fix the problem.

Although the warning messages are only advisory, as many warnings as possible are fixed for any application in the main release. Further validation tests will be added in future releases so it is worth running acdvalid on all local ACD files with each new version of EMBOSS

## References

## Warnings

None.

## Diagnostic Error Messages

## Exit status

It exits with status 0.

## Known bugs

None.

## See also

Program name | Description
--- | ---
acdc | Test an application ACD file
acdpretty | Correctly reformat an application ACD file
acdtable | Generate an HTML table of parameters from an application ACD file
acdtrace | Trace processing of an application ACD file (for testing)

## Author(s)

Peter Rice
European Bioinformatics Institute, Wellcome Trust Genome Campus, Hinxton, Cambridge CB10 1SD, UK

Please report all bugs to the EMBOSS bug team (emboss-bug © emboss.open-bio.org) not to the original author.

## History

Written 2004

## Target users

This program is intended to be used by developers of applications and interfaces.

## Comments

None